stages:
  - build
  - dast
  - vault
  - molecule
  - provision
  - deploy
  - destroy

include:
  - project: 'otus6/pipeline/docker-build'
    file: '.docker-build.yml'
  - project: 'otus6/pipeline/get-secrets'
    file: '.get-secrets.yml'
  - project: 'otus6/pipeline/terraform-apply'
    file: '.terraform-apply.yml'
  - project: 'otus6/pipeline/deploy-ansible'
    file: '.deploy-ansible.yml'
  - project: 'otus6/pipeline/terraform-destroy'
    file: '.terraform-destroy.yml'
  - project: "otus6/pipeline/dast"
    file: ".dast.yml"
  - project: 'otus6/pipeline/molecule-tests'
    file: '.molecule-tests.yml'

default:
  tags:
    - dind_lms

####################
# Tests start here #
####################
baseline:
  stage: dast
  extends: .dast
  variables:
    API_FORMAT: ""

api-scan:
  stage: dast
  extends: .dast
  variables:
    API_FORMAT: "-f openapi"

full-scan:
  stage: dast
  extends: .dast
  variables:
    API_FORMAT: ""

molecule-test:
  stage: molecule
  extends:
    - .molecule-tests
  dependencies:
    - get-secrets
  tags:
    - shell-arch-host

#############################
# Main pipeline starts here #
#############################
docker-build:      
  stage: build
  extends: .docker-build

get-secrets:
  stage: vault
  extends: 
    - .get-secrets
  variables:
    VAULT_SECRETS: "otus6/secrets/${CI_PROJECT_NAME}"
    TARGETS: "ansible terraform tls"

terraform-apply:
  stage: provision
  extends: .terraform-apply  
  allow_failure: true
  dependencies:
    - get-secrets

ansible-playbook:
  stage: deploy
  extends:
    - .deploy-ansible    
  variables:
    ANSIBLE_ROLES_STORE: "galaxy"
  allow_failure: true
  dependencies:
    - get-secrets
    - terraform-apply

terraform-destroy:
  stage: destroy
  extends: .terraform-destroy
  dependencies:
    - get-secrets
    - terraform-apply

